% Homework 1: barre_1D
% Auteur: Benoit LE

clear all
close all
clc
disp('==========================================================')
disp('========== PROPAGATION D''UNE ONDE DANS UNE BARRE =========');
disp('==========================================================');disp(' ');
% ----- DEFINITION DES DONNEES DU PROBLEME -----
% Dimensions de la barre 
L=1e3;       % Longueur (en mm)
S=1e1;       %Section (en mm2)

% Caractristiques mecaniques
E=210e3;  % Module d'Young (MPa)
rho=7500e-9;  % Masse volumique (kg/mm3)

% Chargement a appliquer
F=1000;   % Effort (en N)
tl=1e-3;      % Duree d'application du chargement (en s)

% ----- DEFINITION DU MAILLAGE DE LA STRUCTURE -----
ne=100;      % Nombre d'elements

% ----- DEFINITION DES PARAMETRES DE LA SIMULATION -----
T=0.03;      % Duree de la simulation
dt=1e-7;    % Pas de temps

% Parametres de l'algorithme de Newmark
a=0;
beta=0.25*(1+a)^2;
gamma=0.5+a;

% ----- CHOIX DES PARAMETRES POUR LE POST-TRAITEMENT -----
pas=fix(sqrt(1e0/dt));  % Pas de temps pour l'affichage des rsultats
n=ne+1;  % Choix du noeud ou le deplacement et l'effort normal seront calcules

disp(['Estimation du pas de temps critique: ' num2str((L/ne)/sqrt(E/rho)) ' s'])
disp(['Pas de temps de la simulation: ' num2str(dt) ' s']); disp(' ')

% ----- MATRICES MASSE ET RAIDEUR - CONDITIONS INITIALES -----
t=0:dt:T;  % Vecteur des instants ou la solution sera calcule
[M,K,Fext,U0,Up0]=assemblage(L,S,E,rho,ne,F,t,tl);

% ----- RESOLUTION DU PROBLEME ----
[U,Up,Upp]=newmark(M,K,Fext,U0,Up0,beta,gamma,t,dt);
clear Up Upp Fext
% U=rk4(M,K,U0,Up0,t,dt);

%On rajoute dans la solution U le deplacement du dernier noeud, nul a
%chaque instant (encastrement en x=L)
U=[U;zeros(1,length(t))];

% ----- POST-TRAITEMENT -----
post_traitement(L,S,E,rho,F,ne,t,tl,U,pas,n)