function [U,Up,Upp]=newmark(M,K,F,U0,Up0,beta,gamma,t,dt)

disp('=== Rsolution du problme par l''algorithme de Newmark ===')
tic;
disp('Calcul en cours ...')


%Initialisation des matrices U,Up,Upp
U=zeros(length(U0),length(t));
Up=zeros(length(U0),length(t));
Upp=zeros(length(U0),length(t));

U(:,1)=U0;
Up(:,1)=Up0;
Upp(:,1)=M\(F(:,1)-K*U0);

% Calcul des constantes (pour optimiser le temps de calcul)
S=inv(M+beta*dt^2*K);
a=(0.5-beta)*dt^2;
b=(1-gamma)*dt;
c=beta*dt^2;
d=gamma*dt;

for i=1:length(t)-1
    %Calcul des predicteurs
    U_pr=U(:,i)+dt*Up(:,i)+a*Upp(:,i);
    Up_pr=Up(:,i)+b*Upp(:,i);
    
    %Calcul de l'acceleration
    Upp(:,i+1)=S*(F(:,i+1)-K*U_pr);
    
    % Correction
    U(:,i+1)=U_pr+c*Upp(i+1);
    Up(:,i+1)=Up_pr+d*Upp(i+1);    
end

time=toc;
disp(['Calcul effectu! Temps coul: ' num2str(time) ' s']); disp(' ')

end