function U=rk4(M,K,U0,Up0,t,dt)

disp('= Rsolution du problme par l''algorithme de Runge-Kutta =')
tic;
disp('Calcul en cours ...')

n=length(M(:,1));
Y=zeros(2*n,length(t));
Y(:,1)=[U0;Up0];
A=[zeros(n) eye(n); -M\K zeros(n)];

for i=1:length(t)-1
    y=Y(:,i);
    k1=f(y,t(i));
    k2=f(y+(dt/2)*k1,t(i)+dt/2);
    k3=f(y+(dt/2)*k2,t(i)+dt/2);
    k4=f(y+dt*k3,t(i)+dt);
    
    Y(:,i+1)=y+(dt/6)*(k1+2*k2+2*k3+k4);
end   

function y1=f(y,t)
    F=-1000;
    y1=A*y+[zeros(n,1); M\[F*(t<=1e-3);zeros(n-1,1)]];    
end

U=Y(1:n,:);

time=toc;
disp(['Calcul effectu! Temps coul: ' num2str(time) ' s'])

end